package com.zcxk.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dto.RoleDto;
import com.zcxk.entity.Role;
import com.zcxk.entity.UserEntity;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 角色(Role)表数据库访问层
 *
 * @author makejava
 * @since 2020-10-27 09:13:27
 */
@Mapper
public interface RoleMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Role selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<Role> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param role 实例对象
     * @return 对象列表
     */
    List<Role> selectList(Role role);

    /**
     * 新增数据
     *
     * @param role 实例对象
     * @return 影响行数
     */
    int insert(Role role);

    /**
     * 批量新增
     *
     * @param roles 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(List<Role> roles);

    /**
     * 修改数据
     *
     * @param role 实例对象
     * @return 影响行数
     */
    int update(Role role);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<RoleDto> selectPage(IPage<RoleDto> page, Role role);

    Role findRoleUser(Role role);
    int deleteRoleUser(Role role);
    int deleteRoleMenu(Role role);

    IPage<UserEntity> findUsersByRole(IPage<UserEntity> iPage,Role role);

}